import {Observable} from "rxjs";
import {TemplateRef} from "@angular/core";
import {AbstractControl, FormGroup} from "@angular/forms";

export interface IConfirmOptions {
  title: string;
  message: string;
  confirmText?: string;
  cancelText?: string;
}

export interface IConfirmEvents {
  success: Observable<any>;
  failure: Observable<any>;
  loading: Observable<boolean>;
}

export interface IConfirmForm<TControl extends FormType<TControl> = any> {
  formTemplate?: TemplateRef<any>;
  form?: FormGroup<TControl>
}

export type FormType<TControl = any> = { [K in keyof TControl]: AbstractControl<any>; }

export type ConfirmOptions<TConfirmOptions extends IConfirmOptions> = TConfirmOptions & IConfirmEvents & IConfirmForm;

export interface ICommandDirectiveService<TConfirmOptions extends IConfirmOptions = IConfirmOptions> {
  confirm(options?: ConfirmOptions<TConfirmOptions>): Observable<boolean>;
}
