import {Directive, inject, Input, TemplateRef} from '@angular/core';
import {FormGroup} from "@angular/forms";
import {FormType} from "../abstractions/command-directive-service.abstraction";

@Directive({
  selector: '[duiCommandForm]',
  standalone: true
})
export class CommandFormDirective<TForm extends FormType<TForm>> {
  public readonly template = inject(TemplateRef<any>);

  @Input({ alias: 'commandForm', required: true })
  public form!: FormGroup<TForm>;
}
